from zope.interface import implements, Interface
from tribunal.testing import TestCase


class IFoo(Interface):
    def foo():
        pass


class IBar(Interface):
    def bar():
        pass


class Foo(object):
    """Correctly implements IFoo."""
    implements(IFoo)

    def foo(self):
        pass


class Goo(object):
    """Claims to implement IFoo."""
    implements(IFoo)


class Hoo(object):
    """Implements IFoo but doesn't declare it."""

    def foo(self):
        pass


class Qux(object):
    """Doesn't implement anything."""


class TestAssertImplements(TestCase):

    def test_success(self):
        self.assertImplements(Foo(), IFoo)

    def test_declared_not_implemented(self):
        self.assertImplements(Goo(), IFoo)

    def test_implemented_not_declared(self):
        self.assertRaises(
            self.failureException, self.assertImplements, Hoo(), IFoo)

    def test_not_implemented(self):
        self.assertRaises(
            self.failureException, self.assertImplements, Qux(), IFoo)

    def test_implements_something_else(self):
        self.assertRaises(
            self.failureException, self.assertImplements, Foo(), IBar)
